//
//  Queue.m
//  crepe
//
//  Created by dev on 10/05/31.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <pthread.h>
#import "Queue.h"

@implementation Queue

-(id)init
{
	[super init];
	array = [[NSMutableArray alloc] initWithCapacity:QUEUE_DEFAULT_CAPACITY];
	pthread_mutex_init(&mutex, NULL);
	return self;
}



-(void)dealloc
{
	[array release];
	pthread_mutex_destroy(&mutex);
	[super dealloc];
}



-(void)push:(id)data
{
	pthread_mutex_lock(&mutex);
	
	[array addObject:data];
	
	pthread_mutex_unlock(&mutex);
}



-(id)pop
{
	pthread_mutex_lock(&mutex);
	
	id result = nil;
	if([array count] != 0)
	{
		result = [array objectAtIndex:0];
		[array removeObjectAtIndex:0];
	}
	
	pthread_mutex_unlock(&mutex);
	return result;
}



-(int)count
{
	int result = 0;
	pthread_mutex_lock(&mutex);
	result = [array count];
	pthread_mutex_unlock(&mutex);
	return result;
}

@end
